*DECK MCI2F0
C23456789012345678901234567890123456789012345678901234567890123456789012
      SUBROUTINE MCI2F0(IFTRAK, NG, NL, NR, NSOUT, MXSEG, NT, 
     >                NP, NM, SURF,
     >                MATALB, ALBEDO, INVVOL, SEGLEN, NRSEG, 
     >                EXP2, FLM, FLP, VOID,
     >                SIGANG, SANINV,
     >                SR, FLUX, CUR, MASQ, 
     >                IPRT)
      IMPLICIT  NONE
      INTEGER   IFTRAK, NR, NSOUT, MXSEG, NT, NP, NM, 
     >          IS,IR,IG,IPRT,NOIL, LINE, IANG, NRSEG(MXSEG),
     >          IT, IL, MATALB(-NSOUT:NR), VOID(MXSEG),
     >          NG,IANGO, NL,MASQ(NG)
      REAL      
     >          INVVOL(-NSOUT:NR),
     >          FLM(MXSEG),FLP(MXSEG),
     >          ALBEDO(6),SURF(-NSOUT:-1)
      DOUBLE PRECISION 
     >          FLUX(NG,-NSOUT:NR),
     >          CUR(NG,-NSOUT:-1),
     >          SR(NG,NR),
     >          EXP2(MXSEG),
     >          DZERO
      REAL      SIGANG(NG,-6:NR), SANINV(NG,-6:NR)
      REAL      ALPHA, FMEAN, DFLUX, FL
      REAL      ONE, ZERO
      REAL      TAU, WEIGHT, SEGLEN(MXSEG)
      PARAMETER ( ONE=1.0, ZERO=0.0, DZERO=0.0D0)
C
      REAL             E0, E1, PAS1, DX1, XLIM1
      INTEGER          MEX1, LAU
      PARAMETER      ( MEX1=7936 )
      COMMON /EXP1/ E0(0:MEX1),E1(0:MEX1),PAS1,DX1,XLIM1
C      COMMON /EXP1/ E0(0:MEX1*2+1),PAS1,DX1,XLIM1
C
*
      DO  3 IG=1,NG
       IF( MASQ(IG).EQ.0 )THEN
          DO  1 IS=-NSOUT,-1
             CUR(IG,IS)=FLUX(IG,IS)*ALBEDO(-MATALB(IS))/SURF(IS)
             FLUX(IG,IS)= DZERO
    1     CONTINUE
          DO  2 IR=1,NR
             FLUX(IG,IR)= DZERO
    2     CONTINUE
       ENDIF
    3 CONTINUE
*
C1)   LOOP OVER ALL TRACKS --------------------------------------------
      IANGO = 0
      DO 100 IT= 1, NT
        READ(IFTRAK)  IANG,LINE,WEIGHT,
     >       (NRSEG(IL),IL= 1,LINE),(SEGLEN(IL),IL= 1,LINE)
        DO 200 IG= 1,NG
           IF( MASQ(IG).EQ.0 )THEN
           NOIL = NRSEG(1)
           FL= CUR(IG,NOIL)*WEIGHT
           DO 31 IL= 2, LINE-1
               VOID(IL)=1
               NOIL  = NRSEG(IL)
               TAU = SIGANG(IG,NOIL)* SEGLEN(IL)
               IF( TAU.EQ.ZERO )THEN
                  EXP2(IL)= SEGLEN(IL)
                  VOID(IL)= 0
               ELSE
                  LAU= MIN(INT(TAU*PAS1),MEX1)
                  EXP2(IL)= E0(LAU)+E1(LAU)*TAU
               ENDIF
C* updating the flux
C* -----------------
             IF(VOID(IL).EQ.0) THEN
               FLUX(IG,NOIL)= FLUX(IG,NOIL) + FL*EXP2(IL)
             ELSE
               FLM(IL) = SR(IG,NOIL)* WEIGHT
               ALPHA=FL-FLM(IL)
               FMEAN= ALPHA*EXP2(IL)
               DFLUX= FMEAN
               FLUX(IG,NOIL)= FLUX(IG,NOIL) + DFLUX
C*-------------------
               IF( NOIL.LT.0 )THEN
                 CALL XABORT('MCI2F0: NOT THERE (1)')
               ELSE
                 FL= FL - FMEAN
               ENDIF
             ENDIF
   31      CONTINUE
C*
           NOIL = NRSEG(LINE)
           FLUX(IG,NOIL)=FLUX(IG,NOIL)+ FL
*
           FL= CUR(IG,NOIL)*WEIGHT
           DO 61 IL= LINE-1,2 ,-1
              NOIL  = NRSEG(IL)
C* updating the flux
C* -----------------
             IF(VOID(IL).EQ.0) THEN
               FLUX(IG,NOIL)= FLUX(IG,NOIL) + FL*EXP2(IL)
             ELSE
               ALPHA=FL-FLM(IL)
               FMEAN= ALPHA*EXP2(IL)
               DFLUX= FMEAN
               FLUX(IG,NOIL)= FLUX(IG,NOIL) + DFLUX
C* -----------------
               IF( NOIL.LT.0 )THEN
                 CALL XABORT('MCI2F0: NOT THERE (3)')
               ELSE
                 FL= FL -FMEAN
               ENDIF
             ENDIF
   61      CONTINUE
C*
           NOIL=NRSEG(1)
           FLUX(IG,NOIL)=FLUX(IG,NOIL)+ FL
C*
* MASQUE DES GROUPES
           ENDIF
  200    CONTINUE
  100 CONTINUE
*
      DO  50 IG=1,NG
         IF( MASQ(IG).EQ.0 )THEN
            DO  51 IR=1,NR
               FLUX(IG,IR) = FLUX(IG,IR) * INVVOL(IR) 
     >                       * SANINV(IG,IR) + SR(IG,IR)
   51       CONTINUE
            DO  52 IS=-NSOUT,-1
               CUR(IG,IS) = CUR(IG,IS) * SURF(IS)
   52       CONTINUE
         ENDIF
   50 CONTINUE
*
      RETURN
 1010 FORMAT (1H ,A6,2H: ,1P,I2/(9X,I2))
 1020 FORMAT (1H ,A6,2H: ,1P,10E12.5/(9X,10E12.5))
 1045 FORMAT (5H CUR ,I2,2H: ,1P,10E12.5/(9X,10E12.5))
  130 FORMAT (/28H FLUXES FOR THIS ITERATION :/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
  140 FORMAT (7H FLUX  ,2H: ,1P,10E12.5/(9X,10E12.5))
      END
