*DECK MCI2FC 
C**********************************************************************
      SUBROUTINE MCI2FC(IFTRK2, FACN  , FACF  , EXP2  , DSURF ,
     +                  SURF  , FCSUR , INDSUR, NRSEG , SEGLEN, MATCOD,
     +                  XSTRC , XSDIA , VOL   , NG    , NR    , NS    ,
     +                  MXSEG , MBDSEG, NMAT  , NTRK2 , LETAB ,
     +                  L2LNG , INDS  , IPRT  )
C**********************************************************************
      IMPLICIT  NONE
      INTEGER   IFTRK2, NG, NR, NS, MXSEG, MBDSEG, NMAT, NTRK2,
     >          MATCOD(NR), NRSEG(MXSEG),INDSUR(-NS:-1),
     >          INDS(-NS:-1),ttseg,ttline,
     >          IPRT      
      REAL
     >          SURF(-NS:-1),
     >          SURFTM(-NS:-1),
     >          SEGLEN(MBDSEG), VOL(NR), 
     >          XSTRC(0:NMAT,NG),XSDIA(0:NMAT,NG)
      DOUBLE PRECISION 
     >          FACN(NG,NR), 
     >          FACF(NG,NR), 
     >          FCSUR(NG,-NS:-1),
     >          DSURF(-NS:-1),
     >          EXP2(NG)
      LOGICAL   LETAB, L2LNG
      INTEGER     INTEGER2, INTEGER4, REAL4, REAL8
      PARAMETER ( INTEGER2=2, INTEGER4=3, REAL4=4, REAL8=6 )
C  
C     VARIABLES TEMPORAIRES
      INTEGER   IR, IG, IL, IT, NOIL, NOIL0, NOIL9, IMAT
      INTEGER   IANG, LINE 
      REAL      ONE, ZERO, WEIGHT, TAU, XTMP,XTRTMP
      DOUBLE PRECISION DONE, DZERO, DHALF, DEXTMP
      LOGICAL LPRNT
      PARAMETER ( DONE=1.0D0, DZERO=0.D0, DHALF=0.5D0, 
     >            ONE=1., ZERO=0. )
C
C     MACROBAND VARIABLES
      INTEGER  NLINE, ILINE
C
C     Table de (ONE-EXP)!!!!
      REAL E0, E1, PAS1, DX1, XLIM1
      INTEGER          MEX1, LAU
      PARAMETER      ( MEX1=7936 )
      COMMON /EXP1/ E0(0:MEX1),E1(0:MEX1),PAS1,DX1,XLIM1
C
C
CMD      write(*,*) "MCI2FC: MATCOD", nmat, nr
CMD      write(*,*) matcod
      L2LNG = .FALSE.
      LPRNT = IPRT.GE.5
      LPRNT = .TRUE.
C
      CALL XDRSET(INDS(-NS),NS,0)
      CALL XDRSET(INDSUR(-NS),NS,0)
      DO  3 IR=1,NR
      DO  3 IG=1,NG
          FACN(IG,IR)= DZERO
          FACF(IG,IR)= DZERO
    3 CONTINUE
      DO  5 IR=-NS,-1
        DO  1 IG=1,NG
          FCSUR(IG,IR)= DZERO
    1   CONTINUE
        DSURF(IR)= DZERO
    5 CONTINUE

      CALL MCIRWD( IFTRK2 )
C*    Pjj COMPUTING
C     =============
      ttseg=0
      ttline=0
         DO 100 IT= 1, NTRK2
            READ(IFTRK2)  IANG,LINE,WEIGHT,
     >           (NRSEG(IL),IL= 1,LINE),(SEGLEN(IL),IL= 1,LINE)
C     Calcul les surfaces
            NOIL0= NRSEG(1)
            INDSUR(NOIL0)= NRSEG(2)
            DSURF(NOIL0) = DSURF(NOIL0) +DBLE(WEIGHT)
CD
            NOIL9= NRSEG(LINE)
            INDSUR(NOIL9)= NRSEG(LINE-1)
            DSURF(NOIL9) = DSURF(NOIL9) + DBLE(WEIGHT)
CD
C       Calcul les probabilites 
C step1: When IL=2
            IL=2
            NOIL= NRSEG(2)
            IMAT= MATCOD(NOIL)
            IF( LETAB ) THEN
               DO 101 IG= 1,NG
                  TAU =  XSTRC(IMAT,IG)*SEGLEN(2)
                  LAU = INT( TAU*PAS1 )
                  IF( LAU.GT.MEX1 ) THEN
                     LAU = MEX1
                     L2LNG = .TRUE.
                  ENDIF
                  EXP2(IG) = (E0(LAU)+E1(LAU)*TAU)*WEIGHT
                  FACN(IG,NOIL)= FACN(IG,NOIL) + EXP2(IG)
                  FCSUR(IG,NOIL0)= FCSUR(IG,NOIL0) + EXP2(IG)
 101           CONTINUE
            ELSE
               DO 102 IG= 1,NG
                  TAU =  XSTRC(IMAT,IG)*SEGLEN(2)
                  EXP2(IG)= WEIGHT - EXP(-TAU)*WEIGHT
                  FACN(IG,NOIL)= FACN(IG,NOIL) + EXP2(IG)
                  FCSUR(IG,NOIL0)= FCSUR(IG,NOIL0) + EXP2(IG)
 102           CONTINUE
            ENDIF
c     STEP2: WHEN IL IS NOT AT THE BORD
            IF( LETAB ) THEN
               DO 103 IL= 3, LINE-1
                  NOIL = NRSEG(IL)
                  IMAT = MATCOD(NOIL)
                  DO 104 IG= 1,NG
                     TAU =  XSTRC(IMAT,IG)*SEGLEN(IL)
                     LAU = INT( TAU*PAS1 )
                     IF( LAU.GT.MEX1 ) THEN
                        LAU = MEX1
                        L2LNG = .TRUE.
                     ENDIF
                     EXP2(IG) = ( E0(LAU) + E1(LAU)*TAU ) * WEIGHT
                     FACN(IG,NOIL)= FACN(IG,NOIL) + EXP2(IG)
 104              CONTINUE
 103           CONTINUE
            ELSE
               DO 105 IL= 3, LINE-1
                  NOIL = NRSEG(IL)
                  IMAT = MATCOD(NOIL)
                  DO 106 IG= 1,NG
                     TAU =  XSTRC(IMAT,IG)*SEGLEN(IL)
                     EXP2(IG)= WEIGHT - EXP(-TAU) * WEIGHT
                     FACN(IG,NOIL)= FACN(IG,NOIL) + EXP2(IG)
 106              CONTINUE
 105           CONTINUE
            ENDIF
C     STEP3: WHEN IL= LINE-1
            DO 109 IG= 1,NG
               FCSUR(IG,NOIL9)= FCSUR(IG,NOIL9) + EXP2(IG)
 109        CONTINUE
 100     CONTINUE
CC
      DO  4 IR=1,NR
      DO  4 IG=1,NG
        FACN(IG,IR)= 2.D0*FACN(IG,IR)
        FACF(IG,IR)= FACN(IG,IR)
    4 CONTINUE
C
      DO  7 IR=-NS,-1
        DEXTMP= DSURF(IR)
CD        SURF(IR)= REAL(DEXTMP)
        SURFTM(IR)= REAL(DSURF(IR))
        NOIL= INDSUR(IR)
        IMAT= MATCOD(INDSUR(IR))
        DO  6 IG=1,NG
          XTRTMP=XSTRC(IMAT,IG)
          FACN(IG,NOIL)= FACN(IG,NOIL)
     >                 - FCSUR(IG,IR)*FCSUR(IG,IR)
     >                   /DEXTMP
          FCSUR(IG,IR)= FCSUR(IG,IR)/XSTRC(IMAT,IG)
    6   CONTINUE
    7 CONTINUE
C
      DO  IR=-NS,-1
         SURF(IR)=SURFTM(IR)
      ENDDO
      DO  2 IR=1,NR
      DO  2 IG=1,NG
         FACN(IG,IR)= DONE - FACN(IG,IR)/DBLE(VOL(IR))
     >                       /DBLE( XSTRC(MATCOD(IR),IG) )
         FACN(IG,IR)= FACN(IG,IR)/XSTRC(MATCOD(IR),IG)
    2 CONTINUE
C
      RETURN
      END
