*DECK MCI2FD***********************************************************
      SUBROUTINE MCI2FD(IFTRAK, NG    , NR    , NSOUT , MXSEG , NT    , 
     2                  NMAT  , NANIS , MATALB, NRSEG , MASQ  , INDSUR, 
     3                  KEYANI, SURF  , ALBEDO, INVVOL, SEGLEN, EXP2  ,
     4                  SIGANG, SANINV, XSCAT , XSDIA , SR    , SF    ,
     5                  FLUX  , FLUX1 , CUR   , FL    , FACN  , FACF  , 
     6                  FCSUR , PNL   , ERRMX , MAXCON, LETAB , L2LNG , 
     7                  ITMAX   ,  IPRT  )
C**********************************************************************
      IMPLICIT  NONE
      INTEGER   IFTRAK, NG, NR, NSOUT, MXSEG, NT, NMAT, NANIS,
     >          MATALB(-NSOUT:NR), NRSEG(MXSEG), MASQ(NG),
     >          INDSUR(-NSOUT:-1), KEYANI(1), MAXCON, 
     >          IPRT
      REAL      SURF(-NSOUT:-1), ALBEDO(6), INVVOL(-NSOUT:NR),
     >          SEGLEN(MXSEG),
     >          XSCAT(NG,0:NMAT,0:NANIS,NG), XSDIA(0:NMAT,NG),
     >          PNL(NG)
      REAL      FL(NG,2),
     >          SIGANG(NG,-6:NR), SANINV(NG,-6:NR)
      DOUBLE PRECISION 
     >          FLUX(NG,-NSOUT:NR), 
     >          FLUX1(NG,NR),
     >          CUR(NG,-NSOUT:-1), 
     >          EXP2(NG,MXSEG),
     >          FACN(NG,NR), 
     >          FACF(NG,NR),
     >          FCSUR(NG,-NSOUT:-1),
     >          SF(NG,NR),
     >          SR(NG,NR)     
      LOGICAL   LETAB, L2LNG, LPVM, LMBD
C
      INTEGER     INTEGER2, INTEGER4, REAL4, REAL8, SIZE2
      PARAMETER ( INTEGER2=2, INTEGER4=3, REAL4=4, REAL8=6 )
C
C     VARIALBLES LOCALES
      INTEGER   IS, IR, IG, JG, IL, IT, NOIL, LINE, IANG, ITMAX, 
     >          NOIL0, NOIL9, CONVG, NLINE, ILINE
      DOUBLE PRECISION  FACT, XFACD, DSR, EXTMP
      REAL      FMAX, GMAX, ERRMX
      PARAMETER (FACT=1.0E-2 )
      REAL      TAU, WEIGHT , DELTA, XTMP
C
C     PARAMETERS
      REAL      ONE, ZERO, COUNT
      DOUBLE PRECISION DONE, DZERO,temps_debut,temps_debut1
      PARAMETER ( ONE=1.0, ZERO=0.0, DONE=1.D0, DZERO=0.D0 )
C
      REAL E0, E1, PAS1, DX1, XLIM1
      INTEGER          MEX1, LAU
      PARAMETER      ( MEX1=7936 )
      COMMON /EXP1/ E0(0:MEX1),E1(0:MEX1),PAS1,DX1,XLIM1
C
      INTEGER INDSEG, START
      INDSEG()= ILINE + START   
      START=0
      DO  1 IS=-NSOUT,-1
      DO  1 IG=MAXCON,NG
          CUR(IG,IS) = REAL(FLUX(IG,IS))
     >                  *ALBEDO(-MATALB(IS))/SURF(IS)
          FLUX(IG,IS)= DZERO
    1 CONTINUE
      DO  2 IR=1,NR
      DO  2 IG=MAXCON,NG
             FLUX1(IG,IR)= DZERO
    2 CONTINUE
      COUNT = ONE
C
C1)   LOOP OVER ALL TRACKS --------------------------------------------
C
C*    USING THE EXPONENTIAL TABLE
C*    ===========================
      IF( LETAB .AND. L2LNG ) THEN
         DO 100 IT= 1, NT
            READ(IFTRAK)  IANG,LINE,WEIGHT,
     >           (NRSEG(IL),IL= 1,LINE),(SEGLEN(IL),IL= 1,LINE)
            NOIL0= NRSEG(1)
            NOIL9= NRSEG(LINE)
            DO  131 IG=MAXCON,NG
               FL(IG,1)=  REAL(CUR(IG,NOIL0)*WEIGHT)
               FL(IG,2)=  REAL(CUR(IG,NOIL9)*WEIGHT)
 131        CONTINUE
            DO 101 IL=2,LINE-1
               NOIL= NRSEG(IL)
               DO 102 IG=MAXCON,NG
                  TAU =  SIGANG(IG,NOIL)*SEGLEN(IL)
                  LAU = INT( TAU*PAS1 )
                  LAU = MIN( LAU, MEX1 )
                  EXP2(IG,IL) = E0(LAU)+E1(LAU)*TAU
                  DELTA= (FL(IG,1)-SR(IG,NOIL)*WEIGHT)
                  FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                       + (DELTA*EXP2(IG,IL))
                  FL(IG,1)= FL(IG,1)-(DELTA*EXP2(IG,IL))
 102           CONTINUE
 101        CONTINUE
            DO 103 IL=LINE-1,2,-1
               NOIL= NRSEG(IL)
               DO 104 IG=MAXCON,NG
                  DELTA= (FL(IG,2)-SR(IG,NOIL)*WEIGHT)
                  FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                       + (DELTA*EXP2(IG,IL))
                  FL(IG,2)= FL(IG,2)-(DELTA*EXP2(IG,IL))
 104           CONTINUE
 103        CONTINUE
            DO  133 IG=MAXCON,NG
               FLUX(IG,NOIL9)= FLUX(IG,NOIL9) + FL(IG,1)
               FLUX(IG,NOIL0)= FLUX(IG,NOIL0) + FL(IG,2)
 133        CONTINUE
 100     CONTINUE
      ELSE IF( LETAB .AND. (.NOT.L2LNG) .AND. (.NOT.LMBD) ) THEN
         DO 300 IT= 1, NT
            READ(IFTRAK)  IANG,LINE,WEIGHT,
     >           (NRSEG(IL),IL= 1,LINE),(SEGLEN(IL),IL= 1,LINE)
            NOIL0= NRSEG(1)
            NOIL9= NRSEG(LINE)
            DO  331 IG=MAXCON,NG
               FL(IG,1)= CUR(IG,NOIL0)*WEIGHT
               FL(IG,2)= CUR(IG,NOIL9)*WEIGHT
 331        CONTINUE
            DO 301 IL=2,LINE-1
               NOIL= NRSEG(IL)
               DO 302 IG=MAXCON,NG
                  TAU =  SIGANG(IG,NOIL)*SEGLEN(IL)
                  LAU = INT( TAU*PAS1 )
                  EXP2(IG,IL) = E0(LAU)+E1(LAU)*TAU
                  DELTA= (FL(IG,1)-SR(IG,NOIL)*WEIGHT)
                  FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                      + (DELTA*EXP2(IG,IL))
                  FL(IG,1)= FL(IG,1)-(DELTA*EXP2(IG,IL))
 302           CONTINUE
 301        CONTINUE
            DO 303 IL=LINE-1,2,-1
               NOIL= NRSEG(IL)
               DO 304 IG=MAXCON,NG
                  DELTA= (FL(IG,2)-SR(IG,NOIL)*WEIGHT)
                  FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                      + (DELTA*EXP2(IG,IL))
                  FL(IG,2)= FL(IG,2)-(DELTA*EXP2(IG,IL))
 304           CONTINUE
 303        CONTINUE
            DO  333 IG=MAXCON,NG
               FLUX(IG,NOIL9)= FLUX(IG,NOIL9) + FL(IG,1)
               FLUX(IG,NOIL0)= FLUX(IG,NOIL0) + FL(IG,2)
 333        CONTINUE
 300     CONTINUE
      ELSE IF( .NOT.LETAB ) THEN
C
C*       USING FUNCTION EXP FOR EXPONENTIAL COMPUTING
C        ============================================
         DO 200 IT= 1, NT
            READ(IFTRAK)  IANG,LINE,WEIGHT,
     >           (NRSEG(IL),IL= 1,LINE),(SEGLEN(IL),IL= 1,LINE)
            NOIL0= NRSEG(1)
            NOIL9= NRSEG(LINE)
            DO  231 IG=MAXCON,NG
               FL(IG,1)= CUR(IG,NOIL0)*WEIGHT
               FL(IG,2)= CUR(IG,NOIL9)*WEIGHT
 231        CONTINUE
            DO 201 IL=2,LINE-1
               NOIL= NRSEG(IL)
               DO 202 IG=MAXCON,NG
                  EXP2(IG,IL)= ONE - EXP(-SIGANG(IG,NOIL)* SEGLEN(IL))
                  DELTA= (FL(IG,1)-SR(IG,NOIL)*WEIGHT)
                  FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                      + (DELTA*EXP2(IG,IL))
                  FL(IG,1)= FL(IG,1)-(DELTA*EXP2(IG,IL))
 202           CONTINUE
 201        CONTINUE
            DO 203 IL=LINE-1,2,-1
               NOIL= NRSEG(IL)
               DO 204 IG=MAXCON,NG
                  DELTA= (FL(IG,2)-SR(IG,NOIL)*WEIGHT)
                  FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                      + (DELTA*EXP2(IG,IL))
                  FL(IG,2)= FL(IG,2)-(DELTA*EXP2(IG,IL))
 204           CONTINUE
 203        CONTINUE
            DO  233 IG=MAXCON,NG
               FLUX(IG,NOIL9)= FLUX(IG,NOIL9) + FL(IG,1)
               FLUX(IG,NOIL0)= FLUX(IG,NOIL0) + FL(IG,2)
 233        CONTINUE
 200     CONTINUE
      ENDIF
C
      IF(ITMAX.EQ.0) THEN
C*       IF SCR IS TUNED OFF
C        -------------------
         DO  17 IR=1,NR
         DO  17 IG=MAXCON,NG
            FLUX(IG,IR)=FLUX1(IG,IR)
     >                    * INVVOL(IR)*SANINV(IG,IR)+SR(IG,IR)
 17      CONTINUE
         write(*,*) 'MCI2FD flux : ',(FLUX(1,IR),IR=1,NR)
         RETURN
      ENDIF
      DO   3 IR=-NSOUT, -1
      NOIL= INDSUR(IR)
      DO   3 IG=MAXCON, NG
         FLUX1(IG,NOIL)= FLUX1(IG,NOIL)
     >              - FCSUR(IG,IR)*CUR(IG,IR)*SIGANG(IG,NOIL)
    3 CONTINUE
      DO  20 IR=1,NR
      DO  20 IG=MAXCON,NG
            FLUX1(IG,IR) = ( FLUX1(IG,IR)+SR(IG,IR)*FACF(IG,IR) )
     >                     *INVVOL(IR)*SANINV(IG,IR)      
   20 CONTINUE
      ERRMX= FACT*ERRMX
      ERRMX= MIN(0.01,ERRMX)
C
      DO 10 IR= -NSOUT,-1
      NOIL= INDSUR(IR)
      DO 10 IG=MAXCON,NG
            FLUX(IG,IR)=  FLUX(IG,IR)
     >            - FCSUR(IG,IR) * SR(IG,NOIL)*SIGANG(IG,NOIL)
            FLUX1(IG,NOIL)= FLUX1(IG,NOIL)
     >  + FLUX(IG,IR)/SURF(IR)*FCSUR(IG,IR)*INVVOL(NOIL)
   10 CONTINUE
C
      DO  53 IT=1, ITMAX
        FMAX= ZERO
        GMAX= ZERO
        DO  50 IR=1,NR
        DO  50 IG=MAXCON,NG
              DSR= DZERO
              EXTMP= FLUX(IG,IR) 
              FLUX(IG,IR)  = DZERO
C
              DO 52 JG= 1, NG
                DSR= DSR
     >             + XSCAT(JG,MATALB(IR),KEYANI(1),IG)*FLUX(JG,IR)
   52         CONTINUE
C
              SR(IG,IR)= (DSR+SF(IG,IR)) * PNL(IG) 
              XFACD= XSDIA(MATALB(IR),IG)*FACN(IG,IR)*PNL(IG)
              XFACD= DONE/(DONE-XFACD)
              FLUX(IG,IR) = (FLUX1(IG,IR)+SR(IG,IR)*FACN(IG,IR))
     >                    *XFACD
              FMAX= MAX(FMAX,REAL(ABS(FLUX(IG,IR)-EXTMP)))
              GMAX= MAX(GMAX,REAL(EXTMP))
   50   CONTINUE
        GMAX= FMAX/GMAX
        IF( GMAX.LT.ERRMX ) GOTO 99
   53 CONTINUE
C
   99 CONTINUE
      DO 14 IR= 1,NR
      DO 14 IG=MAXCON,NG
         SR(IG,IR)= SR(IG,IR) + 
     >        FLUX(IG,IR)*XSDIA(MATALB(IR),IG) * PNL(IG)
 14   CONTINUE
      DO 13 IR= -NSOUT,-1
         NOIL= INDSUR(IR)
         DO 13 IG=MAXCON,NG
            FLUX(IG,IR)=  FLUX(IG,IR) + FCSUR(IG,IR)*SR(IG,NOIL)
 13   CONTINUE
cc      write(*,*) "MCI2FD: SURF"
cc      write(*,*) SURF
cc      write(*,*) "MCG2FD: FCSUR"
cc      write(*,*) FCSUR
cc      write(*,*) "MCI2FD: FLUX"
cc      write(*,*) FLUX
cc      write(*,*) "MCI2FD: FLUX1"
cc      write(*,*) FLUX1
cc      stop
C
      RETURN
      END
