C***********************************************************************
      SUBROUTINE MCU2FD(NG    , NR    , NSOUT , MXSEG , 
     +                  NMAT  , NANIS , MATALB, NUMERO , MASQ  , INDSUR, 
     +                  KEYANI, SURF  , ALBEDO, INVVOL, SANINV, LENGHT, 
     +                  EXP2  , SIGANG, XSCAT , XSDIA , SR    , SF    ,
     +                  FLUX  , FLUX1 , CUR   , FL    , FACN  , FACF  , 
     +                  FCSUR , PNL   , ERRMX , MAXCON, LETAB , L2LNG , 
     +                  ITMAX , IPRT  , ISYMM , ANGLES, DENSTY, 
     +                  NANGLE, DENUSR, NTOTCL,NEXTGE,MAXR,REMESH,
     +                  LINMAX, RCUTOF, NSUR,  NVOL, INDEL, MINDIM,
     +                  MAXDIM, ICOORD, INCR,  ICUR, TRKBEG, CONV,
     +                  TRKDIR,  NORE , VOLTRK, KEYMRG )
C M. Dahmani
C**********************************************************************
      IMPLICIT  NONE
      INTEGER       IPRT,NANGLE,NTOTCL,NEXTGE,MAXR,LINMAX,
     >              NSUR,NVOL,NG,NORE,NR,MAXMIX,NSOUT
      REAL          DENUSR, ZMAX
C
      REAL          TRKBEG(NTOTCL), TRKDIR(NTOTCL), CONV(NTOTCL),
     >              REMESH(MAXR), LENGHT(LINMAX), DENSTY(*), RCUTOF,
     >              TRKEND(3), TRKORI(3), TRKOR2(3), PROJC2(3),
     >              ANGEQN(3,3), ANGLE2(3), ANGLE3(3), BARY(3),
     >              TRKCUT(3,2), TCUTOF(3,4), TORIC(3),ANGLES(3,*)
      DOUBLE PRECISION VOLTRK(NSUR:NVOL,0:*)
      INTEGER       MINDIM(NTOTCL), MAXDIM(NTOTCL), ICUR(NTOTCL),
     >              ICOORD(NTOTCL), INCR(NTOTCL), NUMERO(LINMAX),
     >              INDEL(4,*), NSBEG(4), NSEND(4), NSCUT(2),
     >              KEYMRG(NSUR:NVOL),
     >              NCSEG, NOLDS, NNEWS,IVOLTK, ISYMM
      INTEGER       IQUART(4)
      LOGICAL       LANGLE, LPRNT
      EQUIVALENCE ( ANGEQN(1,2), ANGLE2 ), ( ANGEQN(1,3), ANGLE3 )
      CHARACTER     TEDATA*13
      INTEGER       NPAN, IOUT
      DOUBLE PRECISION DZERO, DONE
      PARAMETER   ( NPAN=3, IOUT=6, DZERO=0.0D0 )
C
      INTEGER       NDIM,  I, J, NPOINT, NPO2, NCUTOF, LINM2,
     >              NOTRAK, NSOLAN, IVS,  IVS1, IVS2, IGRP, ISB,
     >              NANGLS, IPAN, NESTIM, JANG, IX, IY, IREF1, I2, I3,
     >              NSOLMX, NTTRK, IANG0, NDEBS, N, IZZ, IANGL, K, K3,
     >              NCROS,  JC
      REAL          ANORM2, A, B
      REAL          DENLIN, RCIRC, R2CIRC, DP, FCUTOF,
     >              SURTOT, VOLTOT, WEIGHT, DEPART, X, Y, ANN, ODDNXT,
     >              TOTLEN, TOTXXX, DDENST
C
      INTEGER   MXSEG, NMAT, NANIS,
     >          MATALB(-NSOUT:NR),  MASQ(NG),
     >          INDSUR(-NSOUT:-1), KEYANI(1), MAXCON
      REAL      SURF(-NSOUT:-1), ALBEDO(6), INVVOL(-NSOUT:NR),
     >          XSCAT(NG,0:NMAT,0:NANIS,NG), XSDIA(0:NMAT,NG),
     >          PNL(NG)
      REAL      FL(NG,2),
     >          SIGANG(NG,-6:NR), SANINV(NG,-6:NR)
      DOUBLE PRECISION 
     >          FLUX(NG,-NSOUT:NR), 
     >          FLUX1(NG,NR),
     >          CUR(NG,-NSOUT:-1), 
     >          EXP2(NG,MXSEG),
     >          FACN(NG,NR), 
     >          FACF(NG,NR),
     >          FCSUR(NG,-NSOUT:-1),
     >          SF(NG,NR),
     >          SR(NG,NR)
      LOGICAL   LETAB, L2LNG
C
      INTEGER     INTEGER2, INTEGER4, REAL4, REAL8, SIZE2
      PARAMETER ( INTEGER2=2, INTEGER4=3, REAL4=4, REAL8=6 )
C
C     VARIALBLES LOCALES
      INTEGER   IS, IR, IG, JG, IL, IT, NOIL, LINE, IANG, ITMAX, 
     >          NOIL0, NOIL9, CONVG, NLINE, ILINE
      DOUBLE PRECISION  FACT, XFACD, DSR, EXTMP
      REAL      FMAX, GMAX, ERRMX
      PARAMETER (FACT=1.0E-2 )
      REAL      TAU, DELTA, XTMP
C
C     PARAMETERS
      REAL      ONE, ZERO, COUNT
      PARAMETER ( ONE=1.0, ZERO=0.0, DONE=1.D0 )
C
      REAL E0, E1, PAS1, DX1, XLIM1
      INTEGER          MEX1, LAU
      PARAMETER      ( MEX1=7936 )
      COMMON /EXP1/ E0(0:MEX1),E1(0:MEX1),PAS1,DX1,XLIM1
C
      INTEGER INDSEG, START
      INDSEG()= ILINE + START   
      ANORM2( A, B ) = A*A + B*B
      START=0
c      INDSEG()= ILINE + ((IL-2)*NLINE)
      LPRNT = IPRT.GE.5
      LPRNT = .TRUE.
C
C
C--------------------------------------------------------------------------
C
      NDIM= 3
C      NSOUT = NS
C      NSOUTM= -NSOUT
C      NREG = NR
C      NGRP = NG
C
C     ONE WEIGHT FOR ALL TRACKS
C     DENLIN= # OF TRACKS / CM
      DENLIN= SQRT(DENUSR)
C
C     COMPUTE THE CIRCUMSCRIBED RADIUS AND
C             THE  COORDINATES FOR THE TRUE CENTER OF THE CELL
      R2CIRC= 0.0
      DO 10 I = 1, 3
         BARY(I)= 0.5 * (REMESH(MAXDIM(I)) + REMESH(MINDIM(I)))
         IF( NEXTGE.EQ.1 )THEN
            CALL XABORT('XELTI3: TUBEZ NOT SUPPORTED')
         ELSE
            R2CIRC =  R2CIRC
     >             + (REMESH(MAXDIM(I)) - REMESH(MINDIM(I)))**2
         ENDIF
   10 CONTINUE
      ZMAX=MAX(ABS(REMESH(MAXDIM(3))),ABS(REMESH(MINDIM(I))))
      R2CIRC= 0.25 * R2CIRC
      RCIRC = SQRT(R2CIRC)
C
C     NPOINT= # OF TRACKS ALONG ONE PERPENDICULAR AXIS
      NPOINT= INT( 2. * RCIRC * DENLIN )
***** BEWARE ***** BEWARE ***** BEWARE ***** BEWARE ***** BEWARE *****
***** CHANGE THIS "NPOINT" PARAMETER HAS TREMENDOUS EFFECTS ON TRACKING
***** BEWARE ***** BEWARE ***** BEWARE ***** BEWARE ***** BEWARE *****
C
C     OTHER POSSIBLE CHOICES (EXPLORED WITHOUT SUCCESS) ARE ==>
C1-)  NPOINT=  INT( 2. * RCIRC * DENLIN ) + 1
C2-)  NPOINT= NINT( 2. * RCIRC * DENLIN )
C3-)  NPOINT= NINT( 2. * RCIRC * DENLIN ) + 1
C
C     KEEP "NPOINT" ODD & CORRECT DENSITY
      NPO2  = NPOINT / 2
      NPOINT= 2 * NPO2 + 1
      DP    = 2. * RCIRC / NPOINT
      DENLIN= 1. / DP
      DENUSR= DENLIN**2
      ODDNXT= (2*NPO2+3) / (2.*RCIRC)
      IF( RCUTOF.EQ.0.0 )THEN
         NCUTOF= 1
      ELSE
         NCUTOF= 4
      ENDIF
      LINM2= LINMAX-2*NCUTOF
      FCUTOF= 1.0/REAL(NCUTOF)
      NOTRAK= 0
      SURTOT= 0.0
      VOLTOT= 0.0
      IQUART(1)=1
      IQUART(2)=1
      IQUART(3)=1
      IQUART(4)=1
      IF(NEXTGE .EQ. 1) THEN
        IQUART(2)=0
        IQUART(3)=0
        IQUART(4)=0
        NSOLAN= (NANGLE * (NANGLE + 2)) / 2
      ELSE
        IF( ISYMM .EQ. 8 .OR. ISYMM .EQ. 24 )THEN
          NSOLAN= (NANGLE * (NANGLE + 2)) / 8
          IQUART(2)=0
          IQUART(3)=0
          IQUART(4)=0
        ELSE IF( ISYMM .EQ. 4 .OR. ISYMM .EQ. 20 )THEN
          NSOLAN= (NANGLE * (NANGLE + 2)) / 4
          IQUART(2)=0
          IQUART(4)=0
        ELSE IF( ISYMM .EQ. 2 .OR. ISYMM .EQ. 18 )THEN
          NSOLAN= (NANGLE * (NANGLE + 2)) / 4
          IQUART(3)=0
          IQUART(4)=0
        ELSE
          NSOLAN= (NANGLE * (NANGLE + 2)) / 2
        ENDIF
      ENDIF
      DDENST= 1.0/(NPAN*DENUSR)
      NANGLS=  (NANGLE * (NANGLE + 2)) / 2
      CALL XELEQN( 3, 0, ANGEQN )
      IANG= 0
      DO 15 JANG= 1, NANGLS
      DO 16 IPAN= 1, NPAN
         CALL    XELEQN( 3, NANGLE, ANGEQN )
   16 CONTINUE
        IF(IQUART(MOD(JANG-1,4)+1).NE.1 ) GO TO 15
        IANG= IANG+1
        DENSTY(IANG)= REAL(2*NSOLAN)
        ANGLES(1,IANG)= ANGEQN(1,1)
        ANGLES(2,IANG)= ANGEQN(2,1)
        ANGLES(3,IANG)= ANGEQN(3,1)
   15 CONTINUE
C
C     TO REINITIATE THE EQN ANGLES
      CALL XELEQN( 3, 0, ANGEQN )
      IF( NEXTGE.EQ.1 )THEN
         DDENST= 12.0*DDENST
      ENDIF
      WEIGHT= 0.5*DDENST/REAL(NSOLAN)
      IF( IPRT.GT.1 )THEN
C
C        PREPARE & PRINT THE ESTIMATED NUMBER OF TRACKS
         NESTIM= 0
         DEPART= - (NPO2+1) * DP
         X     = DEPART
         DO 20 IX = 1, NPOINT
            X     = X + DP
            Y     = DEPART
            DO 20 IY = 1, NPOINT
               Y = Y + DP
               IF( ANORM2( X, Y ) .LE. R2CIRC ) NESTIM= NESTIM + 1
   20    CONTINUE
         WRITE(IOUT,'(1H )')
         WRITE(IOUT,'( 8H0ECHO =  ,I8,20H TRACKS/AXIS/ANGLE      )')
     >                          NPOINT
      WRITE(IOUT,'( 8H ECHO =  ,I8,25H TRACKS/CIRCLE/ANGLE          )')
     >                          NESTIM
         NESTIM= NESTIM * NPAN * NSOLAN
      WRITE(IOUT,'(30H ECHO = NEXT ODD    DENSITY >  ,F15.7,4H/CM2)')
     >                                                ODDNXT**2
      WRITE(IOUT,'( 8H ECHO = ,28H ESTIMATED NUMBER OF TRACKS=  ,I8 )')
     >                                                           NESTIM
C
C        PREPARE PRINTING WITH VARIABLE FORMAT
         WRITE(IOUT,'(1H )')
         WRITE(IOUT,'( 8H0ECHO = ,I3,27H SOLID ANGLES TO BE TRACKED )')
     >                   NANGLS
         NSOLMX= MIN(9, NANGLS/10)
         IREF1 = 0
         WRITE(IOUT,'( 1H0,10(I1,9X))') (IREF1, IZZ=0,NSOLMX)
         WRITE(IOUT,'( 1H ,10(I1,9X))') (MOD(IZZ,10), IZZ=0,NSOLMX)
         WRITE(IOUT,'( 2H 0)')
         TEDATA= '(1H+,TXXX,I1)'
      ENDIF
C-------
C
      DO  1 IS=-NSOUT,-1
      DO  1 IG=MAXCON,NG
          CUR(IG,IS) = REAL(FLUX(IG,IS))
     >                  *ALBEDO(-MATALB(IS))/SURF(IS)
          FLUX(IG,IS)= DZERO
    1 CONTINUE
      DO  2 IR=1,NR
      DO  2 IG=MAXCON,NG
          FLUX1(IG,IR)= DZERO
    2 CONTINUE
      COUNT = ONE
C---------------------------------------------------------------------
C--------------------------TRACK AND COMPUTE FLUX---------------------
C---------------------------------------------------------------------
      IANG  = 0
      IANG0 = 0
      NTTRK = 0
C-------
      DO 290 IANGL= 1, NANGLS
         IANG=IANG+1
         LANGLE= .FALSE.
         IF(IQUART(MOD(IANG-1,4)+1).NE.1)THEN
C----
C  Do not track this angle because of the problem symmetry
C----
           LANGLE= .FALSE.
         ELSE
C----
C  Track this angle
C----
           IANG0= IANG0+1
           LANGLE=.TRUE.
         ENDIF
         IF( IPRT.GT.1) THEN
           IF( MOD(IANGL,100) .EQ. 0 )THEN
             IREF1=IREF1+1
             NDEBS= NSOLMX+1
             NSOLMX=MIN(NDEBS+9, NANGLS/10)
             WRITE(IOUT,'( 1H0,10(I1,9X))')(IREF1,IZZ=NDEBS,NSOLMX)
             WRITE(IOUT,'( 1H ,10(I1,9X))')
     >            (MOD(IZZ,10),IZZ=NDEBS,NSOLMX)
             WRITE(IOUT,'( 2H 0)')
           ELSE
             IF( IPRT.GT.10000.AND.MOD(IANGL,100).NE.0 )THEN
               WRITE(IOUT,'( 1H ,10(I1,9X))')(IREF1,IZZ=NDEBS,NSOLMX)
               WRITE(IOUT,'( 1H ,10(I1,9X))')
     >               (MOD(IZZ,10),IZZ=NDEBS,NSOLMX)
               WRITE(IOUT,'( 2H  )')
             ENDIF
             WRITE(TEDATA(7:9),'(I3.3)') MOD(IANGL,100) + 2
             WRITE(IOUT,TEDATA) MOD(IANGL,10)
           ENDIF
         ENDIF
C
C     NPAN AXES DESCRIPTION (X=0.0, Y=0.0 & Z=0.0)
      DO 250 IPAN= 1, NPAN
         CALL    XELEQN( 3, NANGLE, ANGEQN )
         IF(.NOT.LANGLE) GO TO 250
         IF( NEXTGE.EQ.1 )THEN
            IF( IPAN.NE.2 ) GO TO 250
         ENDIF
         DO 30 I   = 1, 3
            N     = ICOORD(I)
            TRKDIR(N)= ANGEQN(N,1)
            INCR(I)= +1
            IF( TRKDIR(N) .LT. 0.0 ) INCR(I)= -1
C
C           MODIFY ANGLES TO TAKE INTO ACCOUNT DP
            ANGLE2(I)= DP * ANGLE2(I)
            ANGLE3(I)= DP * ANGLE3(I)
            IF( NCUTOF.NE.1 )THEN
               TCUTOF(I,1)= RCUTOF*( ANGLE2(I)+ ANGLE3(I) )
               TCUTOF(I,2)= RCUTOF*( ANGLE2(I)- ANGLE3(I) )
               TCUTOF(I,3)= -TCUTOF(I,2)
               TCUTOF(I,4)= -TCUTOF(I,1)
            ENDIF
C
C           DETERMINE THE ORIGIN OF ALL TRACKS
            TRKOR2(I)= BARY(I) - (NPO2+1)*(ANGLE2(I)+ANGLE3(I))
   30    CONTINUE
         DO 45 I   = 1, 3
            PROJC2(I)= 0.0
            DO 40 J   = 1, 3
               IF( I.EQ.J ) GO TO 40
               PROJC2(I)= PROJC2(I) + TRKDIR(J) * TRKDIR(J)
   40       CONTINUE
   45    CONTINUE
C
C        SCAN ALL TRACKS IN THE PERPENDICULAR PLANE
         DO 180 I2  = 1, NPOINT
            DO 50 J   = 1, 3
               TRKOR2(J)= TRKOR2(J) + ANGLE2(J)
               TRKORI(J)= TRKOR2(J)
   50       CONTINUE
            DO 170 I3  = 1, NPOINT
               ANN   = 0.0
               DO 60 J    = 1, 3
                  TRKORI(J)= TRKORI(J) + ANGLE3(J)
                  ANN= ANN + (TRKORI(J)-BARY(J))**2
   60          CONTINUE
C
C              ELIMINATE TRACKS OUTSIDE CIRCUMSCRIBED CIRCLE
               IF( ANN.GT.R2CIRC ) GO TO 170
C
C              WHICH EXTERNAL SURFACES DO THIS TRACK CROSS ?
               NTTRK=NTTRK+1
               CALL XELLSR(  NDIM, NTOTCL, NSUR, MAXR, REMESH,
     >                      INDEL, MINDIM, MAXDIM, ICOORD, ICUR, INCR,
     >                      TRKORI, TRKDIR, TRKCUT, NSCUT, NCROS,
     >                      TOTLEN)
C
C              WHEN NOT SURFACES ARE CROSSED, ELIMINATE THE TRACK
               IF(NCROS.LT.2) GO TO 170
               DO 70 K= 1, NDIM
                  TRKBEG(K)= TRKCUT(K,1)
                  TRKEND(K)= TRKCUT(K,2)
   70          CONTINUE
               DO 75 K= 1, 4
                  NSBEG(K)= NSCUT(1)
                  NSEND(K)= NSCUT(2)
   75          CONTINUE
               IF( NCUTOF.NE.1 )THEN
                  DO 77 K= 1, 4
                     DO 76 K3= 1, 3
                        TORIC(K3)= TRKORI(K3)+TCUTOF(K3,K)
   76                CONTINUE
                     CALL XELLSR( NDIM, NTOTCL, NSUR, MAXR, REMESH,
     >                       INDEL, MINDIM, MAXDIM, ICOORD, ICUR, INCR,
     >                           TORIC, TRKDIR, TRKCUT, NSCUT, NCROS,
     >                           TOTXXX)
                     IF(NSCUT(1).NE.0) NSBEG(K)= NSCUT(1)
                     IF(NSCUT(2).NE.0) NSEND(K)= NSCUT(2)
   77             CONTINUE
               ENDIF
               CALL XELLIN(   NDIM, NTOTCL, MAXR, REMESH,
     >                NSUR,   NVOL,  INDEL, MINDIM, MAXDIM,
     >              ICOORD,   ICUR,   INCR, TRKBEG, TRKEND, TRKDIR,
     >              PROJC2, TOTLEN,   CONV,  LINM2,
     >              LENGHT(NCUTOF+1), NUMERO(NCUTOF+1), LINE)
               NOTRAK= NOTRAK+1
               DO 78 ISB=1,NCUTOF
                  NUMERO(ISB)= NSBEG(ISB)
                  LENGHT(ISB)= FCUTOF
                  NUMERO(NCUTOF+LINE+ISB)= NSEND(ISB)
                  LENGHT(NCUTOF+LINE+ISB)= FCUTOF
   78          CONTINUE
               LINE= LINE+2*NCUTOF
               IF( IPRT.GT.10000)THEN
                  WRITE(IOUT,6001) NOTRAK,
     >                         NCUTOF,(TRKBEG(JC),JC=1,3),
     >                         NCUTOF,(TRKEND(JC),JC=1,3),
     >                                (TRKDIR(JC),JC=1,3)
                  WRITE(IOUT,6002) (LENGHT(I),NUMERO(I),I=1,LINE)
               ENDIF
                  IF( NORE.EQ.0 )THEN
                     DO 322 I= 1, LINE
                        IF( NUMERO(I).GT.0 )THEN
                           LENGHT(I) = LENGHT(I) *
     >                                 SNGL(VOLTRK(NUMERO(I),IANG0))
                        ENDIF
  322                CONTINUE
                  ENDIF
C
                  DO 333 I= 1, LINE
                     NUMERO(I)= KEYMRG(NUMERO(I))
  333             CONTINUE
C
C                 START MODIFICATIONS 98/06 (G.M.)
C                 COMPRESS TRACKING FILE FOR
C                          SUCCESSIVE IDENTICAL REGIONS
                  NOLDS=NUMERO(1)
                  NCSEG=1
                  DO 344 IL = 2, LINE
                     NNEWS=NUMERO(IL)
                     IF( NNEWS.LT.0 .OR. NNEWS.NE.NOLDS )THEN
                        NOLDS=NNEWS
                        NCSEG=NCSEG+1
                        NUMERO(NCSEG)=NUMERO(IL)
                        LENGHT(NCSEG)=LENGHT(IL)
                     ELSEIF( NNEWS.EQ.NOLDS )THEN
                        LENGHT(NCSEG)=LENGHT(NCSEG)+LENGHT(IL)
                     ENDIF
  344             CONTINUE
                  LINE=NCSEG
C---------------------------------------------------------------------------
C-------------------------- COMPUTE A FLUX----------------------------------
C---------------------------------------------------------------------------
C*    USING THE EXPONENTIAL TABLE
C*    ===========================
             IF( LETAB .AND. L2LNG ) THEN
               	 NOIL0= NUMERO(1)
                 NOIL9= NUMERO(LINE)
                 DO  131 IG=MAXCON,NG
                    FL(IG,1)=  REAL(CUR(IG,NOIL0)*WEIGHT)
                    FL(IG,2)=  REAL(CUR(IG,NOIL9)*WEIGHT)
 131             CONTINUE
                 DO 101 IL=2,LINE-1
                    NOIL= NUMERO(IL)
                    DO 102 IG=MAXCON,NG
                       TAU =  SIGANG(IG,NOIL)*LENGHT(IL)
                       LAU = INT( TAU*PAS1 )
                       LAU = MIN( LAU, MEX1 )
                       EXP2(IG,IL) = E0(LAU)+E1(LAU)*TAU
                       DELTA= (FL(IG,1)-SR(IG,NOIL)*WEIGHT)
                       FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                               + (DELTA*EXP2(IG,IL))
                       FL(IG,1)= FL(IG,1)-(DELTA*EXP2(IG,IL))
 102                CONTINUE
 101             CONTINUE
                 DO 103 IL=LINE-1,2,-1
                    NOIL= NUMERO(IL)
                    DO 104 IG=MAXCON,NG
                       DELTA= (FL(IG,2)-SR(IG,NOIL)*WEIGHT)
                       FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                                + (DELTA*EXP2(IG,IL))
                       FL(IG,2)= FL(IG,2)-(DELTA*EXP2(IG,IL))
 104                CONTINUE
 103             CONTINUE
                 DO  133 IG=MAXCON,NG
                    FLUX(IG,NOIL9)= FLUX(IG,NOIL9) + FL(IG,1)
                    FLUX(IG,NOIL0)= FLUX(IG,NOIL0) + FL(IG,2)
 133             CONTINUE
              ELSE IF( LETAB .AND. (.NOT.L2LNG) ) THEN
                 NOIL0= NUMERO(1)
                 NOIL9= NUMERO(LINE)
                 DO  331 IG=MAXCON,NG
                    FL(IG,1)= CUR(IG,NOIL0)*WEIGHT
                    FL(IG,2)= CUR(IG,NOIL9)*WEIGHT
 331             CONTINUE
                 DO 301 IL=2,LINE-1
                    NOIL= NUMERO(IL)
                    DO 302 IG=MAXCON,NG
                       TAU =  SIGANG(IG,NOIL)*LENGHT(IL)
                       LAU = INT( TAU*PAS1 )
                       EXP2(IG,IL) = E0(LAU)+E1(LAU)*TAU
                       DELTA= (FL(IG,1)-SR(IG,NOIL)*WEIGHT)
                       FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                                + (DELTA*EXP2(IG,IL))
                       FL(IG,1)= FL(IG,1)-(DELTA*EXP2(IG,IL))
 302                CONTINUE
 301             CONTINUE
                 DO 303 IL=LINE-1,2,-1
                    NOIL= NUMERO(IL)
                    DO 304 IG=MAXCON,NG
                       DELTA= (FL(IG,2)-SR(IG,NOIL)*WEIGHT)
                        FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                                + (DELTA*EXP2(IG,IL))
                        FL(IG,2)= FL(IG,2)-(DELTA*EXP2(IG,IL))
 304                CONTINUE
 303             CONTINUE
                 DO  313 IG=MAXCON,NG
                    FLUX(IG,NOIL9)= FLUX(IG,NOIL9) + FL(IG,1)
                    FLUX(IG,NOIL0)= FLUX(IG,NOIL0) + FL(IG,2)
 313             CONTINUE
              ELSE IF( (.NOT.LETAB) ) THEN
C
C*       USING FUNCTION EXP FOR EXPONENTIAL COMPUTING
C        ============================================
                 NOIL0= NUMERO(1)
                 NOIL9= NUMERO(LINE)
                 DO  231 IG=MAXCON,NG
                    FL(IG,1)= CUR(IG,NOIL0)*WEIGHT
                    FL(IG,2)= CUR(IG,NOIL9)*WEIGHT
 231             CONTINUE
                 DO 201 IL=2,LINE-1
                    NOIL= NUMERO(IL)
CRR                 IF(NOIL.LT.0) GOTO 201
                    DO 202 IG=MAXCON,NG
                       EXP2(IG,IL)= ONE - EXP(-SIGANG(IG,NOIL)* 
     >                                                LENGHT(IL))
                       DELTA= (FL(IG,1)-SR(IG,NOIL)*WEIGHT)
                       FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                                  + (DELTA*EXP2(IG,IL))
                       FL(IG,1)= FL(IG,1)-(DELTA*EXP2(IG,IL))
 202                CONTINUE
 201            CONTINUE
                DO 203 IL=LINE-1,2,-1
                   NOIL= NUMERO(IL)
                   DO 204 IG=MAXCON,NG
                      DELTA= (FL(IG,2)-SR(IG,NOIL)*WEIGHT)
                      FLUX1(IG,NOIL)= FLUX1(IG,NOIL) 
     >                                 + (DELTA*EXP2(IG,IL))
                      FL(IG,2)= FL(IG,2)-(DELTA*EXP2(IG,IL))
 204               CONTINUE
 203            CONTINUE
                DO  233 IG=MAXCON,NG
                   FLUX(IG,NOIL9)= FLUX(IG,NOIL9) + FL(IG,1)
                   FLUX(IG,NOIL0)= FLUX(IG,NOIL0) + FL(IG,2)
 233            CONTINUE
              ENDIF
  170       CONTINUE
  180    CONTINUE
  250 CONTINUE
  290 CONTINUE
C
C----------------------- SCR NOT APPLIED -------------------------------
C
      IF(ITMAX.EQ.0) THEN
C*       IF SCR IS TUNED OFF
C        -------------------
C
         DO  17 IR=1,NR
         DO  17 IG=MAXCON,NG
            FLUX(IG,IR)=FLUX1(IG,IR)
     >                    * INVVOL(IR)*SANINV(IG,IR)+SR(IG,IR)
 17      CONTINUE
         RETURN
      ENDIF
C
C------------------------ SCR APPLIED ----------------------------------
C
      DO   3 IR=-NSOUT, -1
      NOIL= INDSUR(IR)
      DO   3 IG=MAXCON, NG
         FLUX1(IG,NOIL)= FLUX1(IG,NOIL)
     >              - FCSUR(IG,IR)*CUR(IG,IR)*SIGANG(IG,NOIL)
    3 CONTINUE
      DO  220 IR=1,NR
      DO  220 IG=MAXCON,NG
            FLUX1(IG,IR) = ( FLUX1(IG,IR)+SR(IG,IR)*FACF(IG,IR) )
     >                     *INVVOL(IR)*SANINV(IG,IR)      
  220 CONTINUE
      ERRMX= FACT*ERRMX
      ERRMX= MIN(0.01,ERRMX)
C
      DO 110 IR= -NSOUT,-1
      NOIL= INDSUR(IR)
      DO 110 IG=MAXCON,NG
            FLUX(IG,IR)=  FLUX(IG,IR)
     >            - FCSUR(IG,IR) * SR(IG,NOIL)*SIGANG(IG,NOIL)
            FLUX1(IG,NOIL)= FLUX1(IG,NOIL)
     >  + FLUX(IG,IR)/SURF(IR)*FCSUR(IG,IR)*INVVOL(NOIL)
  110 CONTINUE
C
      DO  53 IT=1, ITMAX
        FMAX= ZERO
        GMAX= ZERO
        DO  510 IR=1,NR
        DO  510 IG=MAXCON,NG
              DSR= DZERO
              EXTMP= FLUX(IG,IR) 
              FLUX(IG,IR)  = DZERO
C
              DO 52 JG= 1, NG
                DSR= DSR
     >             + XSCAT(JG,MATALB(IR),KEYANI(1),IG)*FLUX(JG,IR)
   52         CONTINUE
C
              SR(IG,IR)= (DSR+SF(IG,IR)) * PNL(IG) 
              XFACD= XSDIA(MATALB(IR),IG)*FACN(IG,IR)*PNL(IG)
              XFACD= DONE/(DONE-XFACD)
              FLUX(IG,IR) = (FLUX1(IG,IR)+SR(IG,IR)*FACN(IG,IR))
     >                    *XFACD
              FMAX= MAX(FMAX,REAL(ABS(FLUX(IG,IR)-EXTMP)))
              GMAX= MAX(GMAX,REAL(EXTMP))
  510   CONTINUE
        GMAX= FMAX/GMAX
        IF( GMAX.LT.ERRMX ) GOTO 99
   53 CONTINUE
C
   99 CONTINUE
      DO 14 IR= 1,NR
      DO 14 IG=MAXCON,NG
         SR(IG,IR)= SR(IG,IR) + 
     >        FLUX(IG,IR)*XSDIA(MATALB(IR),IG) * PNL(IG)
 14   CONTINUE
      DO 13 IR= -NSOUT,-1
         NOIL= INDSUR(IR)
         DO 13 IG=MAXCON,NG
            FLUX(IG,IR)=  FLUX(IG,IR) + FCSUR(IG,IR)*SR(IG,NOIL)
 13   CONTINUE
C
      IF( IPRT.GT.1 )THEN
         WRITE(IOUT,'(1H )')
         WRITE(IOUT,'(27H0ECHO = TRACKING PROPERTIES )')
         WRITE(IOUT,'( 8H0ECHO = ,I3,20H ANGLES AND DENSITY:,
     >               F9.3,4H/CM2)')
     >                         NANGLE, DENUSR
         WRITE(IOUT,'( 8H0ECHO = ,I10,3H / ,I10,
     >                             27H TRACKS NOT STORED ON TAPE /)')
     >                         NOTRAK,NTTRK
      ENDIF
C
 6001 FORMAT(' #',I8,1P,' B',I1,'(',2(E10.2,','),E10.2,')',
     >                  ' E',I1,'(',2(E10.2,','),E10.2,')',
     >                  ' D(',2(E10.2,','),E10.2,')' )
 6002 FORMAT(1P,5(1X,E15.7,1X,I6))
C
      RETURN
      END
