*DECK MOCDOT
      SUBROUTINE MOCDOT(NREG,NGRP,IGDEB,JGDEB,VOL,FRVECT,TOVECT,DPROD)
* 
* ---------------------------  MOCDOT  ---------------------------------
* 
*    1-  PROGRAMME STATISTICS:
* 
*           NAME       :  MOCDOT
*           FUNCTION   :  DOT PRODUCT BETWEEN FRVECT AND TOVECT
* 
*    2-  INPUT AND OUTPUT PARAMETERS:
* 
*          NBELEM  : NUMBER OF WORDS 
*          FRVECT  : VECTOR  1     -  FRVECT(NBELEM)
*          TOVECT  : VECTOR  2     -  FRVECT(NBELEM)
* 
* ---------------------------   MOCDOT  --------------------------------
* 
      INTEGER           NREG,NGRP,IG,IR,IGDEB,JGDEB
      DOUBLE PRECISION  FRVECT(NREG,NGRP),TOVECT(NREG,NGRP)
      DOUBLE PRECISION  DPROD
      REAL              VOL(NREG)
      DPROD = 0.000000000000D+0
      DO 100 IG= IGDEB, NGRP-JGDEB
      DO 200 IR=1,NREG
        DPROD = DPROD +  TOVECT(IR,IG)*FRVECT(IR,IG)*VOL(IR)
 200  CONTINUE
 100  CONTINUE
      RETURN
      END