      FUNCTION LCMIOF(IPLIST,NAMP)
*
*-----------------------------------------------------------------------
*
* GET A SETARA POINTER FOR AN ENTRY IN THE LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*
* OUTPUT PARAMETER:
*  LCMIOF : SETARA POINTER TO THE LCM ENTRY NAMED NAMP.
*
*------------------------------------- AUTHOR: A. HEBERT ; 28/10/93 ----
*
      PARAMETER (LHASH=251)
      INTEGER PTMP
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JCMT=LHASH+9)
      CHARACTER NAMP*(*),NAMT*12,TEXT12*12,HSMG*131
      INTEGER INAMT(3)
      LOGICAL LCATRU,LCAFAL
      PARAMETER (LCATRU=.TRUE.,LCAFAL=.FALSE.)
      COMMON IBASE(1)
*
      NAMT=NAMP
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         WRITE(HSMG,'(32HLCMIOF: UNABLE TO POINT RECORD '',A12,5H'' FRO,
     1   13HM A XSM FILE.)') NAMT
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(25HLCMIOF: THE LINKED LIST '',3A4,8H'' HAS A ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMIOF: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      IPNODE=IBASE(IPLIST+INEXT)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      DO 10 I=IBASE(IPNODE+2+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               LCMIOF=IBASE(IPNODE+10*(I-1)+JDATA)
               RETURN
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
      PTMP=IBASE(IPLIST+IFATH)
      LCMIOF=0
      IF(PTMP.EQ.-1) THEN
         TEXT12='/'
      ELSE
         IP=IBASE(IPLIST+IDIR)
         CALL LCMCAR(TEXT12,LCAFAL,IBASE(PTMP+10*(IP-1)+JCMT))
      ENDIF
      WRITE(HSMG,'(30HLCMIOF: UNABLE TO FIND BLOCK '',A12,9H'' INTO DI,
     1 9HRECTORY '',A12,22H'' IN THE LINKED LIST '',3A4,2H''.)') NAMT,
     2 TEXT12,(IBASE(IPLIST+IHNAM+I),I=0,2)
      CALL XABORT(HSMG)
      END
