      SUBROUTINE LCMVAL(IPLIST,NAMP)
*
*-----------------------------------------------------------------------
*
* VALIDATE THE LCM ENTRIES CONTAINED IN A LINKED LIST.
*
* INPUT PARAMETER:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE BLOCK TO VALIDATE. IF NAMP=' ',
*           THE COMPLETE LINKED LIST IS VALIDATED.
*
*------------------------------------- AUTHOR: A. HEBERT ; 26/10/93 ----
*
      PARAMETER (LHASH=251)
      INTEGER PTMP
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJLON=LHASH+3,JJTYP=LHASH+4,
     1 JIDAT=LHASH+5,JFATH=LHASH+5,JDIR=LHASH+6,JCMT=LHASH+9)
      DIMENSION IBASE(1),RRR1(2),RRR2(2)
      LOGICAL LBASE(1),LERR1,LERR2,LCAFAL
      PARAMETER( LCAFAL=.FALSE.)
      DOUBLE PRECISION DDD1,DDD2
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1)),(RRR1(1),DDD1),
     1 (RRR2(1),DDD2)
      CHARACTER NAMP*(*),NAMT*12,HSMG*131,TEXT12*12,NAMMY*12,CMT*12
*
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(25HLCMVAL: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMVAL: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      PTMP=IBASE(IPLIST+IFATH)
      IF(PTMP.EQ.-1) THEN
         TEXT12='/'
      ELSE
         IP=IBASE(IPLIST+IDIR)
         CALL LCMCAR(TEXT12,LCAFAL,IBASE(PTMP+10*(IP-1)+JCMT))
      ENDIF
      NAMMY=TEXT12
   10 IPNODE=IBASE(IPLIST+INEXT)
      IREF=0
   20 IREF=IREF+1
      IF((IREF.GT.IBASE(IPNODE+1)).AND.(NAMMY.EQ.TEXT12)) THEN
         RETURN
      ELSE IF((IREF.GT.IBASE(IPNODE+1)).AND.(NAMT.NE.' ')) THEN
         RETURN
      ELSE IF(IREF.GT.IBASE(IPNODE+1)) THEN
         IPNODE=IBASE(IPLIST+IFATH)
         IREF=IBASE(IPLIST+IDIR)
         IBASE(IPNODE+10*(IREF-1)+JDATA)=IBASE(IPLIST+INEXT)
         IBASE(IPLIST+INEXT)=IBASE(IPLIST+IFATH)
         IBASE(IPLIST+IFATH)=IBASE(IPNODE+10*(IREF-1)+JFATH)
         IBASE(IPLIST+IDIR)=IBASE(IPNODE+10*(IREF-1)+JDIR)
         PTMP=IBASE(IPLIST+IFATH)
         IF(PTMP.EQ.-1) THEN
            NAMMY='/'
         ELSE
            IP=IBASE(IPLIST+IDIR)
            CALL LCMCAR(NAMMY,LCAFAL,IBASE(PTMP+10*(IP-1)+JCMT))
         ENDIF
         GO TO 20
      ENDIF
      CALL LCMCAR(CMT,LCAFAL,IBASE(IPNODE+10*(IREF-1)+JCMT))
      IF((NAMT.NE.' ').AND.(NAMT.NE.CMT)) GO TO 20
      IF(CMT.EQ.' ') GO TO 20
      PTMP=IPNODE+10*(IREF-1)
      IP1=IBASE(PTMP+JDATA)
      IP2=IP1+IBASE(PTMP+JJLON)-1
      IF(IBASE(PTMP+JJTYP).EQ.0) THEN
         IF(NAMT.NE.' ') RETURN
         IBASE(PTMP+JFATH)=IBASE(IPLIST+IFATH)
         IBASE(IPLIST+IFATH)=IBASE(IPLIST+INEXT)
         IBASE(IPLIST+IDIR)=IREF
         IBASE(IPLIST+INEXT)=IP1
         NAMMY=CMT
         GO TO 10
      ELSE IF((IBASE(PTMP+JJTYP).EQ.1).OR.(IBASE(PTMP+JJTYP).EQ.3)) THEN
         LERR1=IBASE(PTMP+JIDAT).NE.IBASE(IP1)
         LERR2=IBASE(PTMP+JIDAT+1).NE.IBASE(IP2)
         IF(LERR1 .OR. LERR2) 
     >   write(6,*) IBASE(PTMP+JIDAT),IBASE(IP1),
     >   IBASE(PTMP+JIDAT+1),IBASE(IP2)
      ELSE IF(IBASE(PTMP+JJTYP).EQ.2) THEN
         LERR1=BASE(PTMP+JIDAT).NE.BASE(IP1)
         LERR2=BASE(PTMP+JIDAT+1).NE.BASE(IP2)
         IF(LERR1 .OR. LERR2) 
     >   write(6,*) BASE(PTMP+JIDAT),BASE(IP1),
     >   BASE(PTMP+JIDAT+1),BASE(IP2)
      ELSE IF(IBASE(PTMP+JJTYP).EQ.4) THEN
         RRR1(1)=BASE(PTMP+JIDAT)
         RRR1(2)=BASE(PTMP+JIDAT+1)
         RRR2(1)=BASE(IP1)
         RRR2(2)=BASE(IP1+1)
         LERR1=DDD1.NE.DDD2
         RRR1(1)=BASE(PTMP+JIDAT+2)
         RRR1(2)=BASE(PTMP+JIDAT+3)
         RRR2(1)=BASE(IP2-1)
         RRR2(2)=BASE(IP2)
         LERR2=DDD1.NE.DDD2
      ELSE IF(IBASE(PTMP+JJTYP).EQ.5) THEN
         LERR1=LBASE(PTMP+JIDAT).NEQV.LBASE(IP1)
         LERR2=LBASE(PTMP+JIDAT+1).NEQV.LBASE(IP2)
      ELSE IF(IBASE(PTMP+JJTYP).EQ.6) THEN
         LERR1=(BASE(PTMP+JIDAT).NE.BASE(IP1)).OR.
     1   (BASE(PTMP+JIDAT+1).NE.BASE(IP1+1))
         LERR2=(BASE(PTMP+JIDAT+2).NE.BASE(IP2-1)).OR.
     1   (BASE(PTMP+JIDAT+3).NE.BASE(IP2))
      ENDIF
      IF(LERR1) THEN
         WRITE(6,'(15HLCMVAL: BLOCK '',A12,21H'' OF THE LINKED LIST ,
     1   1H'',3A4,28H'' HAVE BEEN OVERWRITTEN (1).)') CMT,
     2   (IBASE(IPLIST+IHNAM+I),I=0,2)
        RETURN
*         CALL XABORT(HSMG)
      ELSE IF(LERR2) THEN
         WRITE(6,'(15HLCMVAL: BLOCK '',A12,21H'' OF THE LINKED LIST ,
     1   1H'',3A4,28H'' HAVE BEEN OVERWRITTEN (2).)') CMT,
     2   (IBASE(IPLIST+IHNAM+I),I=0,2)
        RETURN
*         CALL XABORT(HSMG)
      ENDIF
      GO TO 20
      END
