      SUBROUTINE XSMGET(IPLIST,NAMP,DATA2)
*
*-----------------------------------------------------------------------
*
* COPY A BLOCK FROM THE XSM FILE INTO MEMORY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*   NAMP  : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   DATA2 : INFORMATION ELEMENTS. DIMENSION DATA2(ILONG)
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      INTEGER PFXSM
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,HNAME*12,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      DIMENSION DATA2(*)
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      COMMON IBASE(1)
*
      PFXSM=IPLIST
      WRITE(HNAME,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IF(IBASE(PFXSM+IHEAD).NE.200) THEN
         WRITE(HSMG,'(22HXSMGET: THE XSM FILE '',A12,14H'' HAVE THE WRO,
     1   10HNG HEADER.)') HNAME
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      DO 10 J=1,IBASE(PFXSM+INMT)
      WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10 CONTINUE
      WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      CALL XSMREP(NAMT,1,IBASE(PFXSM+IIFILE),IBASE(PFXSM+IMODIF),CMT,
     1 IBASE(PFXSM+INMT),IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),
     2 MYNAME,IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3 IBASE(PFXSM+IIDIR),III)
      READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      DO 20 J=1,IBASE(PFXSM+INMT)
      READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   20 CONTINUE
      IF(III.GT.0) THEN
*        THE BLOCK EXISTS. RECOVER IT.
         CALL KDIGET(IBASE(PFXSM+IIFILE),DATA2,IBASE(PFXSM+IIOFS+III-1),
     1   IBASE(PFXSM+IJLON+III-1),IRC)
         IF(IRC.NE.0) THEN
            WRITE(HSMG,'(24HXSMGET: KDIGET ERROR NB.,I6,12H ON XSM FILE,
     1      2H '',A12,2H''.)') IRC,HNAME
            CALL XABORT(HSMG)
         ENDIF
         RETURN
      ENDIF
      WRITE(HSMG,'(30HXSMGET: UNABLE TO FIND BLOCK '',A12,9H'' INTO DI,
     1 9HRECTORY '',A12,19H'' IN THE XSM FILE '',A12,2H''.)') NAMT,
     2 MYNAME,HNAME
      CALL XABORT(HSMG)
      END
