*DECK FLUSFL
      SUBROUTINE FLUSFL(IPFLUX,NGROUP,NUNKNO,FUNKNO)
C
C---------------------------  FLUSFL  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLUSFL
C       USE      : SAVE FLUX
C       CREATED  : 2000/01/25
C                  EXTRACTED FROM FLUGFL FOR MORE GENERAL USE
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT:
C      IPFLUX  : POINTER TO THE SOLUTION              I
C      NGROUP  : NUMBER OF GROUPS.                    I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM.     I
C      FUNKNO  : UNKNOWN VECTOR SOLVED FOR.           R(NUNKNO,NGROUP)
C
C---------------------------   FLUSFL  --------------------------------
C
      IMPLICIT    NONE
      CHARACTER   NAMSBR*6
      PARAMETER  (NAMSBR='FLUSFL')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPFLUX,NGROUP,NUNKNO
      REAL        FUNKNO(NUNKNO,NGROUP)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CDIRN*12
      INTEGER     IGROUP
C----
C  STORE UNKNOWN VECTOR IPFLUX
C----
      DO 100 IGROUP=1,NGROUP
        WRITE(CDIRN,'(4HFLUX,I3)') IGROUP
        CALL LCMPUT(IPFLUX,CDIRN,NUNKNO,2,FUNKNO(1,IGROUP))
 100  CONTINUE
      RETURN
      END
