      SUBROUTINE LCMEQU(IPLIS1,IPLIS2)
*
*-----------------------------------------------------------------------
*
* COPY THE INFORMATION CONTAINED IN THE ACTIVE DIRECTORY OF THE LINKED
* LIST OR XSM FILE POINTED BY IPLIS1 INTO THE LINKED LIST OR XSM FILE
* POINTED BY IPLIS2. IPLIS2 IS NOT CREATED BY LCMEQU.
*
* INPUT PARAMETERS:
*  IPLIS1 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
* OUTPUT PARAMETER:
*  IPLIS2 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 27/12/93 ----
*
      PARAMETER (MAXLEV=50,LHASH=251)
      CHARACTER NAMT*12,HSMG*131,MYNAME*12,PATH(MAXLEV)*12,NAMLCM*12,
     1 FIRST(MAXLEV)*12
      INTEGER PTMP
      LOGICAL LCAFAL
      PARAMETER (LCAFAL=.FALSE.)
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJLON=LHASH+3,JJTYP=LHASH+4,JCMT=LHASH+9)
      COMMON IBASE(1)
*
      ILEV=1
      IF(IBASE(IPLIS1+IHEAD).EQ.100) THEN
         IF(IBASE(IPLIS1+IMODE).EQ.0) THEN
            WRITE(HSMG,'(25HLCMEQU: THE LINKED LIST '',3A4,8H'' IS CLO,
     1      4HSED.)') (IBASE(IPLIS1+IHNAM+I),I=0,2)
            CALL XABORT(HSMG)
         ELSE IF(IBASE(IPLIS2+IMODE).EQ.0) THEN
            WRITE(HSMG,'(25HLCMEQU: THE LINKED LIST '',3A4,8H'' IS CLO,
     1      4HSED.)') (IBASE(IPLIS2+IHNAM+I),I=0,2)
            CALL XABORT(HSMG)
         ENDIF
   10    IPNODE=IBASE(IPLIS1+INEXT)
         IREF=0
   20    IREF=IREF+1
         IF(IREF.GT.IBASE(IPNODE+1)) GO TO 50
         PTMP=IPNODE+10*(IREF-1)
         ITYLCM=IBASE(PTMP+JJTYP)
         ILONG=IBASE(PTMP+JJLON)
         CALL LCMCAR(NAMT,LCAFAL,IBASE(PTMP+JCMT))
         IF(ITYLCM.EQ.0) THEN
*           DIRECTORY DATA.
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) THEN
               WRITE(HSMG,'(38HLCMEQU: TOO MANY DIRECTORY LEVELS ON '',
     1         3A4,2H''.)') (IBASE(IPLIS1+IHNAM+I),I=0,2)
               CALL XABORT(HSMG)
            ENDIF
            CALL LCMSIX(IPLIS1,NAMT,1)
            CALL LCMSIX(IPLIS2,NAMT,1)
            GO TO 10
         ELSE IF((ILONG.NE.0).AND.(ITYLCM.LE.6)) THEN
            CALL SETARA(IBASE,ILONG,IASS)
            DO 40 I=0,ILONG-1
   40       IBASE(IASS+I)=IBASE(IBASE(PTMP+JDATA)+I)
            CALL LCMPOF(IPLIS2,NAMT,ILONG,ITYLCM,IASS)
         ENDIF
         GO TO 20
   50    IF(ILEV.GT.1) THEN
            IPNODE=IBASE(IPLIS1+IFATH)
            IREF=IBASE(IPLIS1+IDIR)
            CALL LCMSIX(IPLIS2,' ',2)
            CALL LCMSIX(IPLIS1,' ',2)
            ILEV=ILEV-1
            GO TO 20
         ENDIF
      ELSE IF(IBASE(IPLIS1+IHEAD).EQ.200) THEN
   60    NAMT=' '
         CALL XSMNXT(IPLIS1,NAMT,NAMLCM,MYNAME)
         IF(NAMT.EQ.' ') THEN
            IF(ILEV.EQ.1) RETURN
            NAMT=PATH(ILEV)
            ILEV=ILEV-1
            CALL XSMSIX(IPLIS1,' ',2)
            GO TO 80
         ENDIF
         FIRST(ILEV)=NAMT
*
   70    CALL XSMLEN(IPLIS1,NAMT,ILONG,ITYLCM)
         IF(ITYLCM.EQ.0) THEN
*           DIRECTORY DATA.
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) THEN
               WRITE(HSMG,'(38HLCMEQU: TOO MANY DIRECTORY LEVELS ON '',
     1         A12,2H''.)') NAMLCM
               CALL XABORT(HSMG)
            ENDIF
            CALL XSMSIX(IPLIS1,NAMT,1)
            CALL XSMSIX(IPLIS2,NAMT,1)
            PATH(ILEV)=NAMT
            GO TO 60
         ELSE IF((ILONG.NE.0).AND.(ITYLCM.LE.6)) THEN
            CALL SETARA(IBASE,ILONG,IASS)
            CALL XSMGET(IPLIS1,NAMT,IBASE(IASS))
            CALL XSMPUT(IPLIS2,NAMT,ILONG,ITYLCM,IBASE(IASS))
            CALL RLSARA(IBASE(IASS))
         ENDIF
   80    CALL XSMNXT(IPLIS1,NAMT,NAMLCM,MYNAME)
         IF(NAMT.EQ.FIRST(ILEV)) THEN
            IF(ILEV.EQ.1) RETURN
            NAMT=PATH(ILEV)
            ILEV=ILEV-1
            CALL XSMSIX(IPLIS1,' ',2)
            CALL XSMSIX(IPLIS2,' ',2)
            GO TO 80
         ENDIF
         GO TO 70
      ELSE
         WRITE(HSMG,'(24HLCMEQU: INVALID HEADER (,I5,2H).)')
     1   IBASE(IPLIS1+IHEAD)
         CALL XABORT(HSMG)
      ENDIF
      RETURN
      END
