      SUBROUTINE LCMULT(IPLIST,FLOTT)
*
*-----------------------------------------------------------------------
*
* MULTIPLY THE FLOATING POINT INFORMATION CONTAINED IN THE ACTIVE
* DIRECTORY OF A LINKED LIST OR XSM FILE BY A REAL NUMBER.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  FLOTT  : REAL NUMBER.
*
* OUTPUT PARAMETER:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 02/11/93 ----
*
      CHARACTER NAMT*12,HSMG*131,MYNAME*12,NAMLCM*12
      INTEGER IDUMMY
      REAL RRR(2),RDUMMY
      LOGICAL LCM,LDUMMY
      DOUBLE PRECISION DDD
      COMMON BASE(1)
      EQUIVALENCE (RRR(1),DDD)
*
      CALL LCMVAL(IPLIST,' ')
      NAMT=' '
      CALL LCMNXT(IPLIST,NAMT,MYNAME,NAMLCM,LCM)
      IFILE=KDROPN('DUMMYSQ',0,2,0,0)
      IF(IFILE.LE.0) CALL XABORT('LCMULT: KDROPN FAILURE.')
      CALL LCMEXP(IPLIST,0,IFILE,1,1)
      REWIND(IFILE)
      READ(IFILE) JLEVEL,NAMT,ITY1,ILON1
      IF(JLEVEL.NE.1) CALL XABORT('LCMULT: INVALID EXPORT FILE.')
      ILEVEL=1
   10 IF(ITY1.EQ.3) ILON1=(ILON1+3)/4
      IF((ITY1.EQ.4).OR.(ITY1.EQ.6)) ILON1=2*ILON1
      DO 20 I=1,ILEVEL-JLEVEL
      CALL LCMSIX(IPLIST,' ',2)
   20 CONTINUE
      ILEVEL=JLEVEL
      CALL LCMLEN(IPLIST,NAMT,ILON2,ITY2)
      IF((ILON1.NE.ILON2).OR.(ITY1.NE.ITY2)) THEN
         WRITE(HSMG,'(42HLCMULT: TWO RECORDS ARE OF DIFFERENT TYPE ,
     1   19HOR LENGTH. RECORD='',A12,10H'' LENGTHS=,2I7,7H TYPES=,
     2   2I2)') NAMT,ILON1,ILON2,ITY1,ITY2
         CALL XABORT(HSMG)
      ENDIF
      IF(ITY1.EQ.0) THEN
*        DIRECTORY DATA.
         ILEVEL=ILEVEL+1
         CALL LCMSIX(IPLIST,NAMT,1)
      ELSE IF(ITY1.EQ.1) THEN
         DO 30 I=1,1+(ILON1-1)/8
         READ(IFILE) (IDUMMY,J=1,MIN(8,ILON1-(I-1)*8))
   30    CONTINUE
      ELSE IF((ITY1.EQ.2).OR.(ITY1.EQ.6)) THEN
*        SINGLE PRECISION OR COMPLEX DATA.
         IF(LCM) THEN
            IAS1=LCMIOF(IPLIST,NAMT)
         ELSE
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIST,NAMT,BASE(IAS1))
         ENDIF
         DO 35 I=1,1+(ILON1-1)/8
         READ(IFILE) (RDUMMY,J=1,MIN(8,ILON1-(I-1)*8))
   35    CONTINUE
         DO 40 I=1,ILON1
   40    BASE(IAS1+I-1)=FLOTT*BASE(IAS1+I-1)
         CALL LCMPOF(IPLIST,NAMT,ILON1,ITY1,IAS1)
      ELSE IF(ITY1.EQ.3) THEN
         DO 45 I=1,1+(ILON1-1)/8
         READ(IFILE) (RDUMMY,J=1,MIN(8,ILON1-(I-1)*8))
   45    CONTINUE
      ELSE IF(ITY1.EQ.4) THEN
*        DOUBLE PRECISION DATA.
         IF(LCM) THEN
            IAS1=LCMIOF(IPLIST,NAMT)
         ELSE
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIST,NAMT,BASE(IAS1))
         ENDIF
         DO 50 IL=1,1+(ILON1-1)/8
         READ(IFILE) (DDD,I=1,MIN(4,ILON1/2-(IL-1)*4))
   50    CONTINUE
         DO 55 I=1,ILON1/2
         RRR(1)=BASE(IAS1+(I-1)+I-1)
         RRR(2)=BASE(IAS1+(I-1)+I)
         DDD=DBLE(FLOTT)*DDD
         BASE(IAS1+(I-1)+I-1)=RRR(1)
   55    BASE(IAS1+(I-1)+I)=RRR(2)
         CALL LCMPOF(IPLIST,NAMT,ILON1,4,IAS1)
      ELSE IF(ITY1.EQ.5) THEN
         DO 60 I=1,1+(ILON1-1)/8
         READ(IFILE) (LDUMMY,J=1,MIN(8,ILON1-(I-1)*8))
   60    CONTINUE
      ELSE
         CALL XABORT('LCMULT: INVALID DATA TYPE.')
      ENDIF
      READ(IFILE,END=80) JLEVEL,NAMT,ITY1,ILON1
      GO TO 10
*
   80 DO 90 I=1,ILEVEL-1
      CALL LCMSIX(IPLIST,' ',2)
   90 CONTINUE
      IRC=KDRCLS(IFILE,2)
      IF(IRC.LT.0) CALL XABORT('LCMULT: KDRCLS FAILURE.')
      RETURN
      END
